<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.9.1"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Tactic Arena: src/fonctions_deplacements.c File Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="icon.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Tactic Arena
   </div>
   <div id="projectbrief">Reproduction of Tactic Arena with Custom features</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.1 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search','.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_68267d1309a1af8e8297ef4c3efbcdba.html">src</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#func-members">Functions</a>  </div>
  <div class="headertitle">
<div class="title">fonctions_deplacements.c File Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p>Fonctions liées aux déplacements des personnages.  
<a href="#details">More...</a></p>
<div class="textblock"><code>#include &quot;<a class="el" href="attaques_8h_source.html">../include/attaques.h</a>&quot;</code><br />
<code>#include &quot;<a class="el" href="map_8h_source.html">../include/map.h</a>&quot;</code><br />
<code>#include &quot;<a class="el" href="deplacements_8h_source.html">../include/deplacements.h</a>&quot;</code><br />
<code>#include &quot;<a class="el" href="liste__positions_8h_source.html">../include/liste_positions.h</a>&quot;</code><br />
</div><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="func-members"></a>
Functions</h2></td></tr>
<tr class="memitem:a26d299c86d55c280e797a0e123b153fe"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fonctions__deplacements_8c.html#a26d299c86d55c280e797a0e123b153fe">compter_cases_valides</a> (int taille_zone, <a class="el" href="structt__pos.html">t_pos</a> case_cible)</td></tr>
<tr class="memdesc:a26d299c86d55c280e797a0e123b153fe"><td class="mdescLeft">&#160;</td><td class="mdescRight">Détermine le nombre de cases atteignables pour un déplacement.  <a href="fonctions__deplacements_8c.html#a26d299c86d55c280e797a0e123b153fe">More...</a><br /></td></tr>
<tr class="separator:a26d299c86d55c280e797a0e123b153fe"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ada77b113fdecc7bf30661c1d6b723a39"><td class="memItemLeft" align="right" valign="top"><a class="el" href="structliste__pos__t.html">liste_pos_t</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fonctions__deplacements_8c.html#ada77b113fdecc7bf30661c1d6b723a39">deplacement_valide</a> (<a class="el" href="structpersonnage__s.html">personnage_t</a> *joueur)</td></tr>
<tr class="memdesc:ada77b113fdecc7bf30661c1d6b723a39"><td class="mdescLeft">&#160;</td><td class="mdescRight">Recherche les cases atteignables pour un déplacement et les insere dans une liste.  <a href="fonctions__deplacements_8c.html#ada77b113fdecc7bf30661c1d6b723a39">More...</a><br /></td></tr>
<tr class="separator:ada77b113fdecc7bf30661c1d6b723a39"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a973c8e3405d69ec0267febd08dc338b0"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fonctions__deplacements_8c.html#a973c8e3405d69ec0267febd08dc338b0">effectuer_deplacement</a> (<a class="el" href="structpersonnage__s.html">personnage_t</a> *joueur, <a class="el" href="structt__pos.html">t_pos</a> case_cible)</td></tr>
<tr class="memdesc:a973c8e3405d69ec0267febd08dc338b0"><td class="mdescLeft">&#160;</td><td class="mdescRight">Déplace un personnage sur le terrain de jeu.  <a href="fonctions__deplacements_8c.html#a973c8e3405d69ec0267febd08dc338b0">More...</a><br /></td></tr>
<tr class="separator:a973c8e3405d69ec0267febd08dc338b0"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a096a03a2557a8589a110b85a7d01c7f9"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fonctions__deplacements_8c.html#a096a03a2557a8589a110b85a7d01c7f9">proposer_deplacement_terminal</a> (<a class="el" href="structpersonnage__s.html">personnage_t</a> *joueur)</td></tr>
<tr class="memdesc:a096a03a2557a8589a110b85a7d01c7f9"><td class="mdescLeft">&#160;</td><td class="mdescRight">Proposer un déplacement en version terminale.  <a href="fonctions__deplacements_8c.html#a096a03a2557a8589a110b85a7d01c7f9">More...</a><br /></td></tr>
<tr class="separator:a096a03a2557a8589a110b85a7d01c7f9"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a55f99ec1ac5bff62708fd7284b4cbf95"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fonctions__deplacements_8c.html#a55f99ec1ac5bff62708fd7284b4cbf95">changer_orientation_personnage</a> (<a class="el" href="structpersonnage__s.html">personnage_t</a> *perso, <a class="el" href="structt__pos.html">t_pos</a> arrivee)</td></tr>
<tr class="memdesc:a55f99ec1ac5bff62708fd7284b4cbf95"><td class="mdescLeft">&#160;</td><td class="mdescRight">Change l'orientation d'un personnage.  <a href="fonctions__deplacements_8c.html#a55f99ec1ac5bff62708fd7284b4cbf95">More...</a><br /></td></tr>
<tr class="separator:a55f99ec1ac5bff62708fd7284b4cbf95"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a96c5b2b54bfb139657ecb24a86691dc8"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fonctions__deplacements_8c.html#a96c5b2b54bfb139657ecb24a86691dc8">ajouter_marqueurs_deplacements_carte</a> (<a class="el" href="structliste__pos__t.html">liste_pos_t</a> *liste_positions)</td></tr>
<tr class="memdesc:a96c5b2b54bfb139657ecb24a86691dc8"><td class="mdescLeft">&#160;</td><td class="mdescRight">Ajoute des marqueurs sur la carte qui montrent les cases atteignables pour un déplacement.  <a href="fonctions__deplacements_8c.html#a96c5b2b54bfb139657ecb24a86691dc8">More...</a><br /></td></tr>
<tr class="separator:a96c5b2b54bfb139657ecb24a86691dc8"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a799efd466d42dafb66457884f9c0ea54"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fonctions__deplacements_8c.html#a799efd466d42dafb66457884f9c0ea54">retirer_marqueurs_deplacements_carte</a> (<a class="el" href="structliste__pos__t.html">liste_pos_t</a> *liste_positions)</td></tr>
<tr class="memdesc:a799efd466d42dafb66457884f9c0ea54"><td class="mdescLeft">&#160;</td><td class="mdescRight">Retrait des marqueurs de déplacements sur la carte.  <a href="fonctions__deplacements_8c.html#a799efd466d42dafb66457884f9c0ea54">More...</a><br /></td></tr>
<tr class="separator:a799efd466d42dafb66457884f9c0ea54"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>Fonctions liées aux déplacements des personnages. </p>
<dl class="section author"><dt>Author</dt><dd>Yohann Delacroix </dd></dl>
<dl class="section version"><dt>Version</dt><dd>1.0 </dd></dl>
<dl class="section date"><dt>Date</dt><dd>16 Mars 2021 </dd></dl>
</div><h2 class="groupheader">Function Documentation</h2>
<a id="a96c5b2b54bfb139657ecb24a86691dc8"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a96c5b2b54bfb139657ecb24a86691dc8">&#9670;&nbsp;</a></span>ajouter_marqueurs_deplacements_carte()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void ajouter_marqueurs_deplacements_carte </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structliste__pos__t.html">liste_pos_t</a> *&#160;</td>
          <td class="paramname"><em>liste_positions</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Ajoute des marqueurs sur la carte qui montrent les cases atteignables pour un déplacement. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">liste_positions</td><td>Liste qui contient des positions atteignables </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Aucune valeur de retour Remplit le champ po_deplacement de la structure <a class="el" href="structt__carte.html" title="Structure de données pour une case de la map Contient le type d&#39;emplacement de la case Le personnage ...">t_carte</a> par la valeur 1 </dd></dl>
<div class="fragment"><div class="line"><a name="l00241"></a><span class="lineno">  241</span>&#160;{</div>
<div class="line"><a name="l00242"></a><span class="lineno">  242</span>&#160;    <span class="keywordtype">int</span> i;</div>
<div class="line"><a name="l00243"></a><span class="lineno">  243</span>&#160;    <a class="code" href="structt__pos.html">t_pos</a> position;</div>
<div class="line"><a name="l00244"></a><span class="lineno">  244</span>&#160;    <span class="keywordflow">for</span>(i = 0; i &lt; liste_positions-&gt;nb_elem; i++)</div>
<div class="line"><a name="l00245"></a><span class="lineno">  245</span>&#160;    {</div>
<div class="line"><a name="l00246"></a><span class="lineno">  246</span>&#160;        position = <a class="code" href="liste__positions_8h.html#aec107fdc12479175aa796dd6d8f96324">liste_position_lire</a>(liste_positions, i);</div>
<div class="line"><a name="l00247"></a><span class="lineno">  247</span>&#160;        <a class="code" href="map_8h.html#a44d924cef5877b5891f2824de9365100">map</a>[position.x][position.y].po_deplacement = 1;</div>
<div class="line"><a name="l00248"></a><span class="lineno">  248</span>&#160;    }</div>
<div class="line"><a name="l00249"></a><span class="lineno">  249</span>&#160;}</div>
<div class="ttc" id="aliste__positions_8h_html_aec107fdc12479175aa796dd6d8f96324"><div class="ttname"><a href="liste__positions_8h.html#aec107fdc12479175aa796dd6d8f96324">liste_position_lire</a></div><div class="ttdeci">t_pos liste_position_lire(liste_pos_t *liste_positions, int indice)</div><div class="ttdoc">Lit une position dans la liste à l'indice donné</div><div class="ttdef"><b>Definition:</b> liste_positions.c:101</div></div>
<div class="ttc" id="amap_8h_html_a44d924cef5877b5891f2824de9365100"><div class="ttname"><a href="map_8h.html#a44d924cef5877b5891f2824de9365100">map</a></div><div class="ttdeci">t_carte map[N][M]</div><div class="ttdef"><b>Definition:</b> map.h:54</div></div>
<div class="ttc" id="astructt__pos_html"><div class="ttname"><a href="structt__pos.html">t_pos</a></div><div class="ttdoc">Les position sur la carte.</div></div>
</div><!-- fragment -->
</div>
</div>
<a id="a55f99ec1ac5bff62708fd7284b4cbf95"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a55f99ec1ac5bff62708fd7284b4cbf95">&#9670;&nbsp;</a></span>changer_orientation_personnage()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int changer_orientation_personnage </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structpersonnage__s.html">personnage_t</a> *&#160;</td>
          <td class="paramname"><em>perso</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="structt__pos.html">t_pos</a>&#160;</td>
          <td class="paramname"><em>arrivee</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Change l'orientation d'un personnage. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">perso</td><td>Joueur qui requiert le changement d'orientation </td></tr>
    <tr><td class="paramname">arrivee</td><td>Case d'arrivée du personnage </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Integer code Erreur 1, 0 tout s'est bien passé Calcule selon la position du personnage et la position d'arrivée la direction dans laquelle le personnage regarde </dd></dl>
<div class="fragment"><div class="line"><a name="l00184"></a><span class="lineno">  184</span>&#160;{</div>
<div class="line"><a name="l00185"></a><span class="lineno">  185</span>&#160;    <a class="code" href="structt__pos.html">t_pos</a> depart;</div>
<div class="line"><a name="l00186"></a><span class="lineno">  186</span>&#160;    depart.x = perso-&gt;pos_x;</div>
<div class="line"><a name="l00187"></a><span class="lineno">  187</span>&#160;    depart.y = perso-&gt;pos_y;</div>
<div class="line"><a name="l00188"></a><span class="lineno">  188</span>&#160; </div>
<div class="line"><a name="l00189"></a><span class="lineno">  189</span>&#160;    <span class="keywordtype">int</span> difference_x = arrivee.x - depart.x;</div>
<div class="line"><a name="l00190"></a><span class="lineno">  190</span>&#160;    <span class="keywordtype">int</span> difference_y = arrivee.y - depart.y;</div>
<div class="line"><a name="l00191"></a><span class="lineno">  191</span>&#160; </div>
<div class="line"><a name="l00192"></a><span class="lineno">  192</span>&#160;    <span class="keywordflow">if</span>( abs(difference_x) == abs(difference_y) )<span class="comment">//En cas d&#39;égalité on prend en compte par défaut la position y</span></div>
<div class="line"><a name="l00193"></a><span class="lineno">  193</span>&#160;    {</div>
<div class="line"><a name="l00194"></a><span class="lineno">  194</span>&#160;        <span class="keywordflow">if</span>(difference_y &gt; 0)</div>
<div class="line"><a name="l00195"></a><span class="lineno">  195</span>&#160;        {</div>
<div class="line"><a name="l00196"></a><span class="lineno">  196</span>&#160;            perso-&gt;direction = droite;</div>
<div class="line"><a name="l00197"></a><span class="lineno">  197</span>&#160;        }</div>
<div class="line"><a name="l00198"></a><span class="lineno">  198</span>&#160;        <span class="keywordflow">else</span></div>
<div class="line"><a name="l00199"></a><span class="lineno">  199</span>&#160;        {</div>
<div class="line"><a name="l00200"></a><span class="lineno">  200</span>&#160;            perso-&gt;direction = gauche;</div>
<div class="line"><a name="l00201"></a><span class="lineno">  201</span>&#160;        }</div>
<div class="line"><a name="l00202"></a><span class="lineno">  202</span>&#160;    }</div>
<div class="line"><a name="l00203"></a><span class="lineno">  203</span>&#160;    <span class="keywordflow">else</span></div>
<div class="line"><a name="l00204"></a><span class="lineno">  204</span>&#160;    {</div>
<div class="line"><a name="l00205"></a><span class="lineno">  205</span>&#160;        <span class="keywordflow">if</span>( abs(difference_x) &gt; abs(difference_y) )</div>
<div class="line"><a name="l00206"></a><span class="lineno">  206</span>&#160;        {</div>
<div class="line"><a name="l00207"></a><span class="lineno">  207</span>&#160;            <span class="keywordflow">if</span>(difference_x &gt; 0)</div>
<div class="line"><a name="l00208"></a><span class="lineno">  208</span>&#160;            {</div>
<div class="line"><a name="l00209"></a><span class="lineno">  209</span>&#160;                perso-&gt;direction = bas;</div>
<div class="line"><a name="l00210"></a><span class="lineno">  210</span>&#160;            }</div>
<div class="line"><a name="l00211"></a><span class="lineno">  211</span>&#160;            <span class="keywordflow">else</span></div>
<div class="line"><a name="l00212"></a><span class="lineno">  212</span>&#160;            {</div>
<div class="line"><a name="l00213"></a><span class="lineno">  213</span>&#160;                perso-&gt;direction = haut;</div>
<div class="line"><a name="l00214"></a><span class="lineno">  214</span>&#160;            }</div>
<div class="line"><a name="l00215"></a><span class="lineno">  215</span>&#160;        }</div>
<div class="line"><a name="l00216"></a><span class="lineno">  216</span>&#160;        <span class="keywordflow">else</span></div>
<div class="line"><a name="l00217"></a><span class="lineno">  217</span>&#160;        {</div>
<div class="line"><a name="l00218"></a><span class="lineno">  218</span>&#160;            <span class="keywordflow">if</span>(difference_y &gt; 0)</div>
<div class="line"><a name="l00219"></a><span class="lineno">  219</span>&#160;            {</div>
<div class="line"><a name="l00220"></a><span class="lineno">  220</span>&#160;                perso-&gt;direction = droite;</div>
<div class="line"><a name="l00221"></a><span class="lineno">  221</span>&#160;            }</div>
<div class="line"><a name="l00222"></a><span class="lineno">  222</span>&#160;            <span class="keywordflow">else</span></div>
<div class="line"><a name="l00223"></a><span class="lineno">  223</span>&#160;            {</div>
<div class="line"><a name="l00224"></a><span class="lineno">  224</span>&#160;                perso-&gt;direction = gauche;</div>
<div class="line"><a name="l00225"></a><span class="lineno">  225</span>&#160;            }</div>
<div class="line"><a name="l00226"></a><span class="lineno">  226</span>&#160;        }</div>
<div class="line"><a name="l00227"></a><span class="lineno">  227</span>&#160;    }</div>
<div class="line"><a name="l00228"></a><span class="lineno">  228</span>&#160;    <span class="keywordflow">return</span> 0;</div>
<div class="line"><a name="l00229"></a><span class="lineno">  229</span>&#160;}</div>
</div><!-- fragment -->
</div>
</div>
<a id="a26d299c86d55c280e797a0e123b153fe"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a26d299c86d55c280e797a0e123b153fe">&#9670;&nbsp;</a></span>compter_cases_valides()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int compter_cases_valides </td>
          <td>(</td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>taille_zone</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="structt__pos.html">t_pos</a>&#160;</td>
          <td class="paramname"><em>case_cible</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Détermine le nombre de cases atteignables pour un déplacement. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">taille_zone</td><td>Portée de déplacement du personnage </td></tr>
    <tr><td class="paramname">case_cible</td><td>Position du personnage </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Integer représentant le nombre de cases atteignables </dd></dl>
<div class="fragment"><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;{</div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;    <span class="keywordtype">int</span> cov_y;</div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;    <span class="keywordtype">int</span> seek_x;</div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;    <span class="keywordtype">int</span> seek_y;</div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;    <span class="keywordtype">int</span> x, y;</div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;    <span class="keywordtype">int</span> nombre_de_cases_possibles = 0;</div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;    <span class="keywordflow">for</span>(x = -taille_zone; x &lt;= taille_zone; x++)</div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;    {</div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;        cov_y = taille_zone - abs(x);</div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;        <span class="keywordflow">for</span>(y = -cov_y; y &lt;= cov_y ; y++)</div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;        {</div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;            seek_x = case_cible.x - x;</div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;            seek_y = case_cible.y - y;</div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160; </div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;            <span class="keywordflow">if</span>(seek_x &gt;= 0 &amp;&amp; seek_x &lt; N &amp;&amp; seek_y &gt;=0 &amp;&amp; seek_y &lt; <a class="code" href="map_8h.html#a52037c938e3c1b126c6277da5ca689d0">M</a>)<span class="comment">//Controler si les cases ne sont pas hors de la map</span></div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;            {</div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;                <span class="keywordflow">if</span>(<a class="code" href="map_8h.html#a44d924cef5877b5891f2824de9365100">map</a>[seek_x][seek_y].type_emplacement == <a class="code" href="map_8h.html#a3ee479371002a0a258e5c4111cc6e54f">VIDE</a>)</div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;                {</div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;                    nombre_de_cases_possibles++;</div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;                }</div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;            }</div>
<div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;        }</div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;    }</div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;    <span class="keywordflow">return</span> nombre_de_cases_possibles;</div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;}</div>
<div class="ttc" id="amap_8h_html_a3ee479371002a0a258e5c4111cc6e54f"><div class="ttname"><a href="map_8h.html#a3ee479371002a0a258e5c4111cc6e54f">VIDE</a></div><div class="ttdeci">#define VIDE</div><div class="ttdef"><b>Definition:</b> map.h:25</div></div>
<div class="ttc" id="amap_8h_html_a52037c938e3c1b126c6277da5ca689d0"><div class="ttname"><a href="map_8h.html#a52037c938e3c1b126c6277da5ca689d0">M</a></div><div class="ttdeci">#define M</div><div class="ttdef"><b>Definition:</b> map.h:22</div></div>
</div><!-- fragment -->
</div>
</div>
<a id="ada77b113fdecc7bf30661c1d6b723a39"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ada77b113fdecc7bf30661c1d6b723a39">&#9670;&nbsp;</a></span>deplacement_valide()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="structliste__pos__t.html">liste_pos_t</a>* deplacement_valide </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structpersonnage__s.html">personnage_t</a> *&#160;</td>
          <td class="paramname"><em>joueur</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Recherche les cases atteignables pour un déplacement et les insere dans une liste. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">joueur</td><td>Joueur qui demande un déplacement </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>pointeur sur <a class="el" href="structliste__pos__t.html" title="Liste de positions.">liste_pos_t</a> contenant les positions atteignables </dd></dl>
<div class="fragment"><div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;{</div>
<div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;    <span class="comment">//Initialisations</span></div>
<div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;    <a class="code" href="structliste__pos__t.html">liste_pos_t</a> * liste_de_positions = NULL;</div>
<div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;    <span class="keywordtype">int</span> taille_zone = joueur-&gt;portee.deplacement;</div>
<div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;    <a class="code" href="structt__pos.html">t_pos</a> position_joueur = {joueur-&gt;pos_x, joueur-&gt;pos_y};</div>
<div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;    <a class="code" href="structt__pos.html">t_pos</a> nouvelle_position;    </div>
<div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160; </div>
<div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;    <span class="comment">//Recherche du nombre de cases ciblables pour l&#39;allocation mémoire</span></div>
<div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;    <span class="keywordtype">int</span> nb_positions = <a class="code" href="fonctions__deplacements_8c.html#a26d299c86d55c280e797a0e123b153fe">compter_cases_valides</a>(taille_zone, position_joueur);</div>
<div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;    liste_de_positions = <a class="code" href="liste__positions_8h.html#a8e05bdb09fea5bcdb30ce30fccfe910a">liste_positions_initialiser</a>(nb_positions);</div>
<div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;    </div>
<div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160; </div>
<div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;    <span class="comment">//Remplissage de la liste</span></div>
<div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;    <span class="keywordtype">int</span> cov_y;</div>
<div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;    <span class="keywordtype">int</span> seek_x;</div>
<div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;    <span class="keywordtype">int</span> seek_y;</div>
<div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;    <span class="keywordtype">int</span> x, y;</div>
<div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;    <span class="keywordtype">int</span> indice = 0;</div>
<div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;    <span class="keywordflow">for</span>(x = -taille_zone; x &lt;= taille_zone; x++)</div>
<div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;    {</div>
<div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;        cov_y = taille_zone - abs(x);</div>
<div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;        <span class="keywordflow">for</span>(y = -cov_y; y &lt;= cov_y ; y++)</div>
<div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;        {</div>
<div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;            seek_x = position_joueur.x - x;</div>
<div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;            seek_y = position_joueur.y - y;</div>
<div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160; </div>
<div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;            <span class="keywordflow">if</span>(seek_x &gt;= 0 &amp;&amp; seek_x &lt; N &amp;&amp; seek_y &gt;=0 &amp;&amp; seek_y &lt; <a class="code" href="map_8h.html#a52037c938e3c1b126c6277da5ca689d0">M</a>)<span class="comment">//Controler si les cases ne sont pas hors de la map</span></div>
<div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;            {</div>
<div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;                <span class="keywordflow">if</span>(<a class="code" href="map_8h.html#a44d924cef5877b5891f2824de9365100">map</a>[seek_x][seek_y].type_emplacement == <a class="code" href="map_8h.html#a3ee479371002a0a258e5c4111cc6e54f">VIDE</a>)</div>
<div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;                {</div>
<div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;                    </div>
<div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;                    nouvelle_position.x = seek_x;</div>
<div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;                    nouvelle_position.y = seek_y;</div>
<div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;                    <a class="code" href="liste__positions_8h.html#a11720a017e76c08a4cd5d321a9793cb0">liste_positions_ajouter</a>( liste_de_positions, nouvelle_position, indice );</div>
<div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;                    </div>
<div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;                    indice++;</div>
<div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;                }</div>
<div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;            }</div>
<div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;        }</div>
<div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;    }</div>
<div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160; </div>
<div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;    </div>
<div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;    <span class="keywordflow">return</span> liste_de_positions;</div>
<div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;}</div>
<div class="ttc" id="afonctions__deplacements_8c_html_a26d299c86d55c280e797a0e123b153fe"><div class="ttname"><a href="fonctions__deplacements_8c.html#a26d299c86d55c280e797a0e123b153fe">compter_cases_valides</a></div><div class="ttdeci">int compter_cases_valides(int taille_zone, t_pos case_cible)</div><div class="ttdoc">Détermine le nombre de cases atteignables pour un déplacement.</div><div class="ttdef"><b>Definition:</b> fonctions_deplacements.c:20</div></div>
<div class="ttc" id="aliste__positions_8h_html_a11720a017e76c08a4cd5d321a9793cb0"><div class="ttname"><a href="liste__positions_8h.html#a11720a017e76c08a4cd5d321a9793cb0">liste_positions_ajouter</a></div><div class="ttdeci">err_t liste_positions_ajouter(liste_pos_t *liste, t_pos position, int indice)</div><div class="ttdoc">Ajoute une position à la liste.</div><div class="ttdef"><b>Definition:</b> liste_positions.c:78</div></div>
<div class="ttc" id="aliste__positions_8h_html_a8e05bdb09fea5bcdb30ce30fccfe910a"><div class="ttname"><a href="liste__positions_8h.html#a8e05bdb09fea5bcdb30ce30fccfe910a">liste_positions_initialiser</a></div><div class="ttdeci">liste_pos_t * liste_positions_initialiser(int nb_elements)</div><div class="ttdoc">Initialise une liste de positions de n élements.</div><div class="ttdef"><b>Definition:</b> liste_positions.c:24</div></div>
<div class="ttc" id="astructliste__pos__t_html"><div class="ttname"><a href="structliste__pos__t.html">liste_pos_t</a></div><div class="ttdoc">Liste de positions.</div></div>
</div><!-- fragment -->
</div>
</div>
<a id="a973c8e3405d69ec0267febd08dc338b0"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a973c8e3405d69ec0267febd08dc338b0">&#9670;&nbsp;</a></span>effectuer_deplacement()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int effectuer_deplacement </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structpersonnage__s.html">personnage_t</a> *&#160;</td>
          <td class="paramname"><em>joueur</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="structt__pos.html">t_pos</a>&#160;</td>
          <td class="paramname"><em>case_cible</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Déplace un personnage sur le terrain de jeu. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">joueur</td><td>Joueur qui demande un déplacement </td></tr>
    <tr><td class="paramname">case_cible</td><td>Case ciblée par le joueur pour le déplacement </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Integer code Erreur 1, 0 tout s'est bien passé Controle si le déplacement est valide Change l'orientation du personnage après le déplacement </dd></dl>
<div class="fragment"><div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;{</div>
<div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;    <span class="keywordtype">int</span> i;  </div>
<div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;    <a class="code" href="structliste__pos__t.html">liste_pos_t</a> * liste_de_positions = <a class="code" href="fonctions__deplacements_8c.html#ada77b113fdecc7bf30661c1d6b723a39">deplacement_valide</a>(joueur);</div>
<div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;    <a class="code" href="structt__pos.html">t_pos</a> position_possible;    </div>
<div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160; </div>
<div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;    <span class="keywordflow">for</span>(i = 0; i &lt; liste_de_positions-&gt;nb_elem; i++)</div>
<div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160;    {</div>
<div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;        position_possible = <a class="code" href="liste__positions_8h.html#aec107fdc12479175aa796dd6d8f96324">liste_position_lire</a>(liste_de_positions, i);</div>
<div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160; </div>
<div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;        <span class="keywordflow">if</span>(position_possible.x == case_cible.x &amp;&amp; position_possible.y == case_cible.y)<span class="comment">//Si la position est valide</span></div>
<div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;        {</div>
<div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;            <span class="comment">//Déplacement du personnage</span></div>
<div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;            <a class="code" href="fonctions__deplacements_8c.html#a55f99ec1ac5bff62708fd7284b4cbf95">changer_orientation_personnage</a>(joueur, case_cible);</div>
<div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;            <a class="code" href="map_8h.html#a44d924cef5877b5891f2824de9365100">map</a>[joueur-&gt;pos_x][joueur-&gt;pos_y].type_emplacement = <a class="code" href="map_8h.html#a3ee479371002a0a258e5c4111cc6e54f">VIDE</a>;</div>
<div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;            <a class="code" href="map_8h.html#a44d924cef5877b5891f2824de9365100">map</a>[joueur-&gt;pos_x][joueur-&gt;pos_y].perso = NULL;</div>
<div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160;            joueur-&gt;pos_x = case_cible.x;</div>
<div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160;            joueur-&gt;pos_y = case_cible.y;</div>
<div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;            <a class="code" href="map_8h.html#a44d924cef5877b5891f2824de9365100">map</a>[case_cible.x][case_cible.y].type_emplacement = <a class="code" href="map_8h.html#a76e5d06f666d634e30f4278a747569a5">PERSO</a>;</div>
<div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;            <a class="code" href="map_8h.html#a44d924cef5877b5891f2824de9365100">map</a>[case_cible.x][case_cible.y].perso = joueur;</div>
<div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160; </div>
<div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;            </div>
<div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160;            <span class="keywordflow">return</span> 0;           </div>
<div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160;        }</div>
<div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;    }</div>
<div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160; </div>
<div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160;    <span class="comment">//Le personnage n&#39;a pas pu se déplacer</span></div>
<div class="line"><a name="l00138"></a><span class="lineno">  138</span>&#160;    <a class="code" href="liste__positions_8h.html#a362d66d4093adabef784e4c8a71b3d89">liste_positions_detruire</a>( &amp;liste_de_positions );</div>
<div class="line"><a name="l00139"></a><span class="lineno">  139</span>&#160;    <span class="keywordflow">return</span> 1;</div>
<div class="line"><a name="l00140"></a><span class="lineno">  140</span>&#160;}</div>
<div class="ttc" id="afonctions__deplacements_8c_html_a55f99ec1ac5bff62708fd7284b4cbf95"><div class="ttname"><a href="fonctions__deplacements_8c.html#a55f99ec1ac5bff62708fd7284b4cbf95">changer_orientation_personnage</a></div><div class="ttdeci">int changer_orientation_personnage(personnage_t *perso, t_pos arrivee)</div><div class="ttdoc">Change l'orientation d'un personnage.</div><div class="ttdef"><b>Definition:</b> fonctions_deplacements.c:183</div></div>
<div class="ttc" id="afonctions__deplacements_8c_html_ada77b113fdecc7bf30661c1d6b723a39"><div class="ttname"><a href="fonctions__deplacements_8c.html#ada77b113fdecc7bf30661c1d6b723a39">deplacement_valide</a></div><div class="ttdeci">liste_pos_t * deplacement_valide(personnage_t *joueur)</div><div class="ttdoc">Recherche les cases atteignables pour un déplacement et les insere dans une liste.</div><div class="ttdef"><b>Definition:</b> fonctions_deplacements.c:55</div></div>
<div class="ttc" id="aliste__positions_8h_html_a362d66d4093adabef784e4c8a71b3d89"><div class="ttname"><a href="liste__positions_8h.html#a362d66d4093adabef784e4c8a71b3d89">liste_positions_detruire</a></div><div class="ttdeci">err_t liste_positions_detruire(liste_pos_t **liste)</div><div class="ttdoc">Détruit une liste de positions.</div><div class="ttdef"><b>Definition:</b> liste_positions.c:54</div></div>
<div class="ttc" id="amap_8h_html_a76e5d06f666d634e30f4278a747569a5"><div class="ttname"><a href="map_8h.html#a76e5d06f666d634e30f4278a747569a5">PERSO</a></div><div class="ttdeci">#define PERSO</div><div class="ttdef"><b>Definition:</b> map.h:26</div></div>
</div><!-- fragment -->
</div>
</div>
<a id="a096a03a2557a8589a110b85a7d01c7f9"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a096a03a2557a8589a110b85a7d01c7f9">&#9670;&nbsp;</a></span>proposer_deplacement_terminal()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void proposer_deplacement_terminal </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structpersonnage__s.html">personnage_t</a> *&#160;</td>
          <td class="paramname"><em>joueur</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Proposer un déplacement en version terminale. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">joueur</td><td>Joueur qui demande un déplacement </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Aucune valeur de retour Invite l'utilisateur à rentrer des coordonnées par entrée clavier </dd></dl>
<div class="fragment"><div class="line"><a name="l00151"></a><span class="lineno">  151</span>&#160;{</div>
<div class="line"><a name="l00152"></a><span class="lineno">  152</span>&#160;    <span class="keywordtype">int</span> deplacement_effectue = 0;</div>
<div class="line"><a name="l00153"></a><span class="lineno">  153</span>&#160;    <span class="keywordflow">do</span></div>
<div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;    {</div>
<div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160;        <a class="code" href="structt__pos.html">t_pos</a> case_choisie;</div>
<div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160;        printf(<span class="stringliteral">&quot;Déplacement --- Choisir les coordonnées [x,y]. \n&quot;</span>);</div>
<div class="line"><a name="l00157"></a><span class="lineno">  157</span>&#160;        printf(<span class="stringliteral">&quot;x : &quot;</span>);</div>
<div class="line"><a name="l00158"></a><span class="lineno">  158</span>&#160;        scanf(<span class="stringliteral">&quot;%i&quot;</span>, &amp;(case_choisie.x));</div>
<div class="line"><a name="l00159"></a><span class="lineno">  159</span>&#160;        printf(<span class="stringliteral">&quot;y : &quot;</span>);</div>
<div class="line"><a name="l00160"></a><span class="lineno">  160</span>&#160;        scanf(<span class="stringliteral">&quot;%i&quot;</span>, &amp;(case_choisie.y));</div>
<div class="line"><a name="l00161"></a><span class="lineno">  161</span>&#160;        deplacement_effectue = <a class="code" href="fonctions__deplacements_8c.html#a973c8e3405d69ec0267febd08dc338b0">effectuer_deplacement</a>(joueur, case_choisie);</div>
<div class="line"><a name="l00162"></a><span class="lineno">  162</span>&#160;        <span class="keywordflow">if</span>( deplacement_effectue == 1 )</div>
<div class="line"><a name="l00163"></a><span class="lineno">  163</span>&#160;        {</div>
<div class="line"><a name="l00164"></a><span class="lineno">  164</span>&#160;            printf(<span class="stringliteral">&quot;Coordonnées invalides\n&quot;</span>);</div>
<div class="line"><a name="l00165"></a><span class="lineno">  165</span>&#160;            <span class="keywordflow">do</span></div>
<div class="line"><a name="l00166"></a><span class="lineno">  166</span>&#160;            {</div>
<div class="line"><a name="l00167"></a><span class="lineno">  167</span>&#160;                printf(<span class="stringliteral">&quot;Tenter un nouveau déplacement ? [1: Oui. 0: Non.]\n&quot;</span>);</div>
<div class="line"><a name="l00168"></a><span class="lineno">  168</span>&#160;                scanf(<span class="stringliteral">&quot;%i&quot;</span>, &amp;deplacement_effectue);</div>
<div class="line"><a name="l00169"></a><span class="lineno">  169</span>&#160;            }<span class="keywordflow">while</span>(deplacement_effectue &lt; 0 || deplacement_effectue &gt; 1);</div>
<div class="line"><a name="l00170"></a><span class="lineno">  170</span>&#160;        }</div>
<div class="line"><a name="l00171"></a><span class="lineno">  171</span>&#160;    }<span class="keywordflow">while</span>(deplacement_effectue == 1);</div>
<div class="line"><a name="l00172"></a><span class="lineno">  172</span>&#160;}</div>
<div class="ttc" id="afonctions__deplacements_8c_html_a973c8e3405d69ec0267febd08dc338b0"><div class="ttname"><a href="fonctions__deplacements_8c.html#a973c8e3405d69ec0267febd08dc338b0">effectuer_deplacement</a></div><div class="ttdeci">int effectuer_deplacement(personnage_t *joueur, t_pos case_cible)</div><div class="ttdoc">Déplace un personnage sur le terrain de jeu.</div><div class="ttdef"><b>Definition:</b> fonctions_deplacements.c:111</div></div>
</div><!-- fragment -->
</div>
</div>
<a id="a799efd466d42dafb66457884f9c0ea54"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a799efd466d42dafb66457884f9c0ea54">&#9670;&nbsp;</a></span>retirer_marqueurs_deplacements_carte()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void retirer_marqueurs_deplacements_carte </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structliste__pos__t.html">liste_pos_t</a> *&#160;</td>
          <td class="paramname"><em>liste_positions</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Retrait des marqueurs de déplacements sur la carte. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">liste_positions</td><td>Liste qui contient des positions atteignables </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Aucune valeur de retour Remplit le champ po_deplacement de la structure <a class="el" href="structt__carte.html" title="Structure de données pour une case de la map Contient le type d&#39;emplacement de la case Le personnage ...">t_carte</a> par la valeur 0 </dd></dl>
<div class="fragment"><div class="line"><a name="l00259"></a><span class="lineno">  259</span>&#160;{</div>
<div class="line"><a name="l00260"></a><span class="lineno">  260</span>&#160;    <span class="keywordtype">int</span> i;</div>
<div class="line"><a name="l00261"></a><span class="lineno">  261</span>&#160;    <a class="code" href="structt__pos.html">t_pos</a> position;</div>
<div class="line"><a name="l00262"></a><span class="lineno">  262</span>&#160;    <span class="keywordflow">for</span>(i = 0; i &lt; liste_positions-&gt;nb_elem; i++)</div>
<div class="line"><a name="l00263"></a><span class="lineno">  263</span>&#160;    {</div>
<div class="line"><a name="l00264"></a><span class="lineno">  264</span>&#160;        position = <a class="code" href="liste__positions_8h.html#aec107fdc12479175aa796dd6d8f96324">liste_position_lire</a>(liste_positions, i);</div>
<div class="line"><a name="l00265"></a><span class="lineno">  265</span>&#160;        <a class="code" href="map_8h.html#a44d924cef5877b5891f2824de9365100">map</a>[position.x][position.y].po_deplacement = 0;</div>
<div class="line"><a name="l00266"></a><span class="lineno">  266</span>&#160;    }</div>
<div class="line"><a name="l00267"></a><span class="lineno">  267</span>&#160;}</div>
</div><!-- fragment -->
</div>
</div>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.1
</small></address>
</body>
</html>
